#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"

#include "game/level_update.h"

#include "levels/scripts.h"


/* Fast64 begin persistent block [includes] */
/* Fast64 end persistent block [includes] */

#include "make_const_nonconst.h"
#include "levels/co/header.h"

/* Fast64 begin persistent block [scripts] */
/* Fast64 end persistent block [scripts] */

const LevelScript level_co_entry[] = {
	INIT_LEVEL(),
	LOAD_MIO0(0x7, _co_segment_7SegmentRomStart, _co_segment_7SegmentRomEnd), 
	LOAD_MIO0(0xa, _water_skybox_mio0SegmentRomStart, _water_skybox_mio0SegmentRomEnd), 
	ALLOC_LEVEL_POOL(),
	MARIO(MODEL_MARIO, 0x00000001, bhvMario),

	/* Fast64 begin persistent block [level commands] */
	/* Fast64 end persistent block [level commands] */

	AREA(1, co_area_1),
		WARP_NODE(0x0A, LEVEL_BOB, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		WARP_NODE(0xF0, LEVEL_BOB, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		WARP_NODE(0xF1, LEVEL_BOB, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		OBJECT(E_MODEL_EXCLAMATION_BOX, 5359, -333, -7221, 0, 0, 0, (1 << 16), id_bhvExclamationBox),
		OBJECT(E_MODEL_YELLOW_COIN, -3853, -623, -6689, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -463, 5594, 6561, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3, 5594, 6752, 0, -135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -922, 5594, 6752, 0, 135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 187, 4502, 7211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1113, 4502, 7211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -463, 4502, 7861, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -463, 4502, 6561, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -922, 4502, 7671, 0, -135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3, 4502, 6752, 0, -135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -922, 4502, 6752, 0, 135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3, 4502, 7671, 0, 135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 187, 2317, 7211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1113, 2317, 7211, 0, 0, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -463, 2317, 7861, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -463, 2317, 6561, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -922, 2317, 7671, 0, -135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3, 2317, 6752, 0, -135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -922, 2317, 6752, 0, 135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3, 2317, 7671, 0, 135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 187, 132, 7211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1113, 132, 7211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -463, 132, 7861, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -463, 132, 6561, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -922, 132, 7671, 0, -135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3, 132, 6752, 0, -135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -922, 132, 6752, 0, 135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3, 132, 7671, 0, 135, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 7347, -623, 1211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 6047, -623, 1211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 6697, -623, 1861, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 6697, -623, 561, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3653, 177, 6211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -4953, 177, 6211, 0, 0, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -4303, 177, 6861, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -4303, 177, 5561, 0, -90, 0, 0x00000000, id_bhvOneCoin),
		OBJECT(E_MODEL_GOOMBA, 1691, -650, 1593, 0, -90, 0, 0x00000000, id_bhvGoomba),
		OBJECT(E_MODEL_GOOMBA, -5309, 150, 7593, 0, -90, 0, 0x00000000, id_bhvGoomba),
		OBJECT(E_MODEL_GOOMBA, 1691, -650, -407, 0, -90, 0, 0x00000000, id_bhvGoomba),
		OBJECT(E_MODEL_GOOMBA, 3691, -650, -1407, 0, -90, 0, 0x00000000, id_bhvGoomba),
		OBJECT(E_MODEL_GOOMBA, 3691, -650, 2593, 0, -90, 0, 0x00000000, id_bhvGoomba),
		OBJECT(E_MODEL_BUBBLY_TREE, 2393, -753, 1837, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, 4270, -834, -855, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -1300, -768, -200, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, 400, -817, -700, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -2100, -341, 2400, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, 4958, -457, 7881, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, 2900, -212, 6400, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, 1900, -25, 8200, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, 6900, -429, 8400, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, 5700, -755, 6300, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -4100, 0, 4000, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -5500, 0, 4700, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -5400, 0, 6900, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -3100, 0, 7900, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -5071, -712, -1617, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -2100, -853, -3600, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -4458, -754, -5131, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -2039, -890, -9968, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(E_MODEL_BUBBLY_TREE, -4900, -147, 1700, 0, -90, 0, 0x00000000, id_bhvTree),
		OBJECT(MODEL_NONE, -5200, -400, -10300, 0, 45, 0, 0x000A0000, bhvSpinAirborneWarp),
		MARIO_POS(0x01, 45, -5200, -400, -10300),
		TERRAIN(co_area_1_collision),
		MACRO_OBJECTS(co_area_1_macro_objs),
		SET_BACKGROUND_MUSIC(0x00, SEQ_LEVEL_UNDERGROUND),
		TERRAIN_TYPE(TERRAIN_GRASS),
		/* Fast64 begin persistent block [area commands] */
		/* Fast64 end persistent block [area commands] */
	END_AREA(),

	FREE_LEVEL_POOL(),
	MARIO_POS(0x01, 45, -5200, -400, -10300),
	CALL(0, lvl_init_or_update),
	CALL_LOOP(1, lvl_init_or_update),
	CLEAR_LEVEL(),
	SLEEP_BEFORE_EXIT(1),
	EXIT(),
};
