#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"

#include "game/level_update.h"

#include "levels/scripts.h"


/* Fast64 begin persistent block [includes] */
/* Fast64 end persistent block [includes] */

#include "make_const_nonconst.h"
#include "levels/cs/header.h"

/* Fast64 begin persistent block [scripts] */
/* Fast64 end persistent block [scripts] */

const LevelScript level_cs_entry[] = {
	INIT_LEVEL(),
	LOAD_MIO0(0x7, _cs_segment_7SegmentRomStart, _cs_segment_7SegmentRomEnd), 
	LOAD_MIO0(0xb, _effect_mio0SegmentRomStart, _effect_mio0SegmentRomEnd), 
	LOAD_MIO0(0xa, _ccm_skybox_mio0SegmentRomStart, _ccm_skybox_mio0SegmentRomEnd), 
	ALLOC_LEVEL_POOL(),
	MARIO(MODEL_MARIO, 0x00000001, bhvMario),

	/* Fast64 begin persistent block [level commands] */
	/* Fast64 end persistent block [level commands] */

	AREA(1, cs_area_1),
		WARP_NODE(0x0A, LEVEL_TOTWC, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		OBJECT(E_MODEL_BLUE_COIN, 3600, 6217, -806, 0, 90, 0, 0x00000000, id_bhvHiddenBlueCoin),
		OBJECT(E_MODEL_BLUE_COIN, 3600, 5875, -165, 0, 90, 0, 0x00000000, id_bhvHiddenBlueCoin),
		OBJECT(E_MODEL_BLUE_COIN, 3600, 5607, 347, 0, 90, 0, 0x00000000, id_bhvHiddenBlueCoin),
		OBJECT(E_MODEL_BLUE_COIN, 3600, 5302, 923, 0, 90, 0, 0x00000000, id_bhvHiddenBlueCoin),
		OBJECT(E_MODEL_BLUE_COIN, 3600, 4987, 1547, 0, 90, 0, 0x00000000, id_bhvHiddenBlueCoin),
		OBJECT(E_MODEL_BLUE_COIN, 3600, 4617, 2283, 0, 90, 0, 0x00000000, id_bhvHiddenBlueCoin),
		OBJECT(E_MODEL_BLUE_COIN, 3549, 4526, 2906, 0, 90, 0, 0x00000000, id_bhvHiddenBlueCoin),
		OBJECT(E_MODEL_BLUE_COIN, 3170, 4526, 3497, 0, 90, 0, 0x00000000, id_bhvHiddenBlueCoin),
		OBJECT(E_MODEL_BLUE_COIN_SWITCH, 5200, 6400, -3117, 0, 90, 0, 0x00000000, id_bhvBlueCoinSwitch),
		OBJECT(E_MODEL_YELLOW_COIN, 3640, 6167, -687, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3640, 5334, 857, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3640, 4882, 1730, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3640, 4530, 2471, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3284, 4530, 3344, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 2499, 4530, 3885, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 389, 4091, 3997, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 27, 3974, 3997, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3054, 3347, 2558, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -87, 3133, 856, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 1062, 2235, 856, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 2118, 1732, 856, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3186, 1732, 310, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3586, 1732, -831, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 2625, 1732, -2211, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 179, 1339, -2386, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -496, 1346, -2386, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1443, 1346, -1672, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1676, 1346, -464, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1559, 1178, 492, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, 451, 2239, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, 290, 2005, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, 37, 1736, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, -265, 1458, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, -617, 1185, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, -968, 893, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, -1299, 590, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, -1689, 308, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, -1943, 93, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, -2240, -141, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -6364, -2465, -375, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -4489, -2686, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -4002, -2832, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3553, -2964, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3134, -3125, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -2729, -3276, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -2329, -3407, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1978, -3525, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1569, -3646, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1188, -3763, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -360, -5623, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 16, -5974, -2341, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(MODEL_NONE, 5600, 6800, -3480, 0, 0, 0, 0x000A0000, bhvSpinAirborneWarp),
		MARIO_POS(0x01, 0, 5600, 6800, -3480),
		TERRAIN(cs_area_1_collision),
		MACRO_OBJECTS(cs_area_1_macro_objs),
		SET_BACKGROUND_MUSIC(0x00, SEQ_LEVEL_SLIDE),
		TERRAIN_TYPE(TERRAIN_SLIDE),
		/* Fast64 begin persistent block [area commands] */
		/* Fast64 end persistent block [area commands] */
	END_AREA(),

	FREE_LEVEL_POOL(),
	MARIO_POS(0x01, 0, 5600, 6800, -3480),
	CALL(0, lvl_init_or_update),
	CALL_LOOP(1, lvl_init_or_update),
	CLEAR_LEVEL(),
	SLEEP_BEFORE_EXIT(1),
	EXIT(),
};
