#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"

#include "game/level_update.h"

#include "levels/scripts.h"


/* Fast64 begin persistent block [includes] */
/* Fast64 end persistent block [includes] */

#include "make_const_nonconst.h"
#include "levels/mc/header.h"

/* Fast64 begin persistent block [scripts] */
/* Fast64 end persistent block [scripts] */

const LevelScript level_mc_entry[] = {
	INIT_LEVEL(),
	LOAD_MIO0(0x7, _mc_segment_7SegmentRomStart, _mc_segment_7SegmentRomEnd), 
	LOAD_MIO0(0xa, _cloud_floor_skybox_mio0SegmentRomStart, _cloud_floor_skybox_mio0SegmentRomEnd), 
	ALLOC_LEVEL_POOL(),
	MARIO(MODEL_MARIO, 0x00000001, bhvMario),

	/* Fast64 begin persistent block [level commands] */
	/* Fast64 end persistent block [level commands] */

	AREA(1, mc_area_1),
		WARP_NODE(0x0A, LEVEL_TOTWC, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		OBJECT(E_MODEL_YELLOW_COIN, -253, 2220, 3437, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1700, 3800, -10200, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3172, 3053, 3447, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 4813, 3509, 3008, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 4800, 3800, -800, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3900, 3800, -1700, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 5700, 3800, -1700, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 4800, 3800, -2700, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 4900, 3800, -6400, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 3100, 3800, -10200, 0, 90, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_GOOMBA, -1221, 2056, 3211, 0, 90, 0, 0x00000000, id_bhvGoomba),
		MARIO_POS(0x0A, -180, 0, 0, 0),
		OBJECT(E_MODEL_TTC_ROTATING_HEXAGON, 4823, 3509, 2058, 0, 90, 0, 0x00000000, id_bhvRotatingPlatform),
		OBJECT(E_MODEL_BITS_SEESAW_PLATFORM, 1421, 2056, 3426, 0, 90, 0, 0x00000000, id_bhvSeesawPlatform),
		OBJECT(E_MODEL_BITS_SEESAW_PLATFORM, 700, 3600, -11300, 0, 90, 0, 0x00000000, id_bhvSeesawPlatform),
		OBJECT(E_MODEL_BITS_SEESAW_PLATFORM, 4830, 3600, -4570, 0, 0, 0, 0x00000000, id_bhvSeesawPlatform),
		TERRAIN(mc_area_1_collision),
		MACRO_OBJECTS(mc_area_1_macro_objs),
		SET_BACKGROUND_MUSIC(0x00, SEQ_LEVEL_SLIDE),
		TERRAIN_TYPE(TERRAIN_GRASS),
		/* Fast64 begin persistent block [area commands] */
		/* Fast64 end persistent block [area commands] */
	END_AREA(),

	FREE_LEVEL_POOL(),
	MARIO_POS(0x0A, -180, 0, 0, 0),
	CALL(0, lvl_init_or_update),
	CALL_LOOP(1, lvl_init_or_update),
	CLEAR_LEVEL(),
	SLEEP_BEFORE_EXIT(1),
	EXIT(),
};
