#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"

#include "game/level_update.h"

#include "levels/scripts.h"


/* Fast64 begin persistent block [includes] */
/* Fast64 end persistent block [includes] */

#include "make_const_nonconst.h"
#include "levels/sl/header.h"

/* Fast64 begin persistent block [scripts] */
/* Fast64 end persistent block [scripts] */

const LevelScript level_sl_entry[] = {
	INIT_LEVEL(),
	LOAD_MIO0(0x7, _sl_segment_7SegmentRomStart, _sl_segment_7SegmentRomEnd), 
	ALLOC_LEVEL_POOL(),
	MARIO(MODEL_MARIO, 0x00000001, bhvMario),

	/* Fast64 begin persistent block [level commands] */
	/* Fast64 end persistent block [level commands] */

	AREA(1, sl_area_1),
		WARP_NODE(0x0A, LEVEL_SL, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		OBJECT(E_MODEL_AMP, -1412, 6355, -6803, 0, 90, 0, 0x00000000, id_bhvCirclingAmp),
		OBJECT(E_MODEL_YELLOW_COIN, 2305, -544, 6977, 0, 180, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -95, 56, 6977, 0, 180, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -95, 806, 3977, 0, 180, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 2305, 1586, 677, 0, 180, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, 2305, 1556, -2423, 0, 180, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -3095, 1856, -5323, 0, 180, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_YELLOW_COIN, -1445, 6356, -6623, 0, 180, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_FLYGUY, 2305, 1961, -923, 0, 180, 0, 0x00000000, id_bhvFlyGuy),
		OBJECT(E_MODEL_UP_PLATFORM1, 840, 6100, -6790, 0, 0, 0, 0x00000000, id_bhvUpRotatingPlatform),
		OBJECT(E_MODEL_UP_PLATFORM1, 811, 10689, 2020, 0, 0, 0, 0x00000000, id_bhvUpRotatingPlatform),
		MARIO_POS(0x01, 180, 2305, -344, 9077),
		OBJECT(E_MODEL_YELLOW_COIN, -95, 816, 677, 0, 180, 0, 0x00000000, id_bhvYellowCoin),
		OBJECT(E_MODEL_AMP, -4495, 6355, -6723, 0, 90, 0, 0x00000000, id_bhvCirclingAmp),
		OBJECT(E_MODEL_SCUTTLEBUG, 2300, 1908, 700, 0, 90, 0, 0x00000000, id_bhvScuttlebug),
		OBJECT(E_MODEL_BITS_SEESAW_PLATFORM, -1295, 1456, -5323, 0, 90, 0, 0x00000000, id_bhvSeesawPlatform),
		OBJECT(E_MODEL_UP_STALAGMITE, -135, 813, 267, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, 286, 806, 4339, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, 1799, -548, 6593, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, 2700, 1577, 477, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, 1940, 1577, -1328, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, 2608, 1577, -3605, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, 653, 1577, -4833, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -3103, 1823, -5775, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -3615, 1965, -5763, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -4930, 2044, -4899, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -3937, 6357, -7243, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -4910, 6357, -7181, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -1384, 6357, -7202, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -723, 11074, -74, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -929, 11074, -671, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_UP_STALAGMITE, -2186, 11074, -33, 0, 180, 0, 0x00000000, id_bhvRandomAnimatedTexture),
		OBJECT(E_MODEL_RR_SWINGING_PLATFORM, 417, 1373, 2310, 0, -90, 0, 0x00000000, id_bhvSwingPlatform),
		TERRAIN(sl_area_1_collision),
		MACRO_OBJECTS(sl_area_1_macro_objs),
		SET_BACKGROUND_MUSIC(0x00, SEQ_EVENT_MERRY_GO_ROUND),
		TERRAIN_TYPE(TERRAIN_SPOOKY),
		/* Fast64 begin persistent block [area commands] */
		/* Fast64 end persistent block [area commands] */
	END_AREA(),

	FREE_LEVEL_POOL(),
	MARIO_POS(0x01, 180, 2305, -344, 9077),
	CALL(0, lvl_init_or_update),
	CALL_LOOP(1, lvl_init_or_update),
	CLEAR_LEVEL(),
	SLEEP_BEFORE_EXIT(1),
	EXIT(),
};
